<?php
/**
 * This file implements the Blogalaxia Tags plugin.
 *
 * For the most recent and complete Plugin API documentation
 * see {@link Plugin} in ../evocore/_plugin.class.php.
 *
 * @package plugins
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author lnieves: Larry Nieves - {@link http://cronicaslinuxeras.com/}
 *
 * @version $Id: _blogalaxia_tags.plugin.php,v 0.2 2007/07/27 22:18:08 lnieves Exp $
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );


/**
 * Blogalaxia_Tags Plugin
 *
 * This plugin responds to virtually all possible plugin events :P
 *
 * @package plugins
 */
class blogalaxia_tags_plugin extends Plugin
{
	/**
	 * Variables below MUST be overriden by plugin implementations,
	 * either in the subclass declaration or in the subclass constructor.
	 */
	var $name = 'Blogalaxia Tags';
	var $code = 'b2BlgxTags';
	var $priority = 90;
	var $version = '2.0';
	var $group = 'rendering';
	var $author = 'Larry Nieves';
	var $help_url = 'http://cronicaslinuxeras.com/extension_etiquetas_blogalaxia';  // empty URL defaults to manual wiki


	/*
	 * These variables MAY be overriden.
	 */
	var $apply_rendering = 'opt-in';
	var $number_of_installs = 1;


	/**
	 * Init
	 *
	 * This gets called after a plugin has been registered/instantiated.
	 */
	function PluginInit( & $params )
	{
		$this->short_desc = T_('Blogalaxia Tags');
		$this->long_desc = T_('It adds blogalaxia-type tags at end of post');
	}

	/* Define HTML Hook */
	function RenderItemAsHtml( & $params )
  {
    $params['data'] = $this->insert_blogalaxia_tags( & $params ) ;
    return true ;
  }

  /* Define XML Hooke. The same as before */
  function RenderItemAsXml ( & $params )
  {
    $this -> RenderItemAsHtml ( & $params) ;
    return true ;
  }

	/**
	 * We trigger an extra event ourself (which we also provide ourselves).
	 *
	 * 
	 */
	function insert_blogalaxia_tags( & $params )
	{
    global $cache_postcats, $app_version;
    $content = & $params['data'] ;
    $item = & $params['Item'] ;
    $base_url = 'http://www.blogalaxia.com/tags/' ; 
    $img_path = $this->get_plugin_url('true').  'img/blogalaxia.gif' ;

    /* This changed for version > 2. we have to take care */
    if ( $app_version < 2 ) {
      $item_type = $item->typ_ID ;
    } else {
      $item_type = $item->ptyp_ID ;
    }
    if ( $item_type != 1 ) /* don't do it for links */ return $content ;
    cat_load_postcats_cache();
    $categoryIDs = $cache_postcats[$item->ID];
    $taglinks = array();
		foreach( $categoryIDs as $cat_ID )
		{
			$cat = get_the_category_by_ID($cat_ID);
			$cat_name = format_to_output( $cat["cat_name"], 'text' );
      $tag = htmlentities( trim( $cat_name ), ENT_NOQUOTES, 'UTF-8' ) ;
      // Keep only one char in entities!
      $tag = preg_replace( '/&(.).+?;/', '$1', $tag );
      // Substituye espacios por '+'
      $tag = strtolower( preg_replace( '/(\s)+/', '+', $tag ) ) ;
      $taglinks[] = '<a href="'. $base_url . $tag . '" rel="tag">' . $cat_name . '</a>' ;
    }
    $content .= '<div class="bg-tags"><img src="' ;
    $content .=  $img_path . '" alt="Etiquetas Blogalaxia" />&nbsp;' ;
    $content .= implode( ', ', $taglinks ) ;
    $content .= '</div>' ;
    return $content ;
	}
}

/****** CHANGELOG *****
 * lun ene 21 11:53:30 CET 2008 (v0.2) We add a version test to account for the 
 * change after 2.0 of item types. ($Item->typ_ID pre-2.x ; $Item->ptyp_ID 
 * post-2.x.
 ****** END CHANGELOG *****/
/* vi: ts=2 sw=2 et nu nowrap
 */
?>
